import processing.core.*; 
import processing.xml.*; 

import de.bezier.data.sql.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class KeywordFrequency2012 extends PApplet {

//import libraries. 


MySQL msql;

// data containers
ArrayList tArray;
ArrayList itemtypeArray;
float span = 0; // total number of transactions

// color palette
int[] palette = {
  0xff9F9694, 0xff791F33, 0xffBA3D49, 0xffF1E6D4, 0xffE2E1DC, 0xff678C8B, 0xff8FA89B, 0xffA2BAB0, 0xffD0EDDE, 0xffB3B597, 0xff262B30, 
  0xffE09A25, 0xffF0D770, 0xffF2EDBC, 0xffC51C30, 0xffFFFFCD, 0xffCC5C54, 0xffF69162, 0xff85A562, 0xff7AB5DB, 0xffFDF6DD, 0xffFEE406
};

// fonts
PFont font0, font1, font2;

// spacing variables
int barWidth = 10;
int barHeight = 20;
int verticalSpacing = 5;
int leftBorder = 10;

String[] sw;

public void setup() {
  // canvas setup
  size(900, 900); //size of the sketch window
  colorMode(HSB, 360, 100, 100);
  textAlign(LEFT, CENTER); // (horizontal,vertical)
  translate(width/2, height/2);
  smooth();

  font0 = loadFont("Miso-48.vlw");
  font1 = loadFont("Miso-Bold-48.vlw");
  font2 = loadFont("QuicksandLight-Regular-48.vlw");
//  font2 = loadFont("QuicksandBold-Regular-48.vlw");
  textFont(font0, 17);
  
  String[] lines = loadStrings("stopwords.txt");
  sw = new String[lines.length];
  
  for (int i = 0; i < lines.length; i++) {
//    println(lines[i]);
    sw[i] = lines[i];
//    String[] words = split(lines[i], '\t');
  }
  
  // create data containers
  tArray = new ArrayList();
  itemtypeArray = new ArrayList();

  // connecting to the database
  msql = new MySQL( this, "mist.mat.ucsb.edu", "spl1", "bkang", "kang4848" ); //host, database, user, password

  if ( msql.connect() )
  {
    // String query="select date(cout),date(cin),itemtype,timestampdiff(HOUR,cout,cin)/24.0 from inraw where cout between '2011-01-10' and '2011-01-11' order by itemtype;";
    // String query = "SELECT deweyClass, count(*) FROM inraw WHERE year(cout) like 2012 and (LOWER(title) like '% social network%' OR LOWER(title) like '% twitter%' OR LOWER(title) like '% facebook%' OR LOWER(title) like '% linkedin%') GROUP BY deweyClass ORDER BY count(*) DESC;"
    String query = "SELECT keyword, count(*) as count  FROM `keyword` group by keyword order by count desc limit 100;";
    println(query);
    msql.query(query);
    msql.next();

    int count = 0;
    while ( msql.next () ) {
      tArray.add(new Entity(msql.getString(1), msql.getInt(2)));
      span += msql.getInt(2);
      count++;
      //println(count + "\t" + msql.getString(1) + "\t" + msql.getInt(2));
    }
  }
  else
  {
    println(" connection failed !");
  }

  // compute radius and coordinate of each circle(entity)
  float xSum = 0;
  float rSum = 0;
  for (int i = 0; i < tArray.size(); i++) { 
    // An ArrayList doesn't know what it is storing so we have to CAST the object coming out
    Entity t = (Entity) tArray.get(i);
    t.rad = (PApplet.parseFloat(t.count) / span)*width;
    xSum += PApplet.parseFloat(t.count);
    rSum += t.rad;
    t.angle = (xSum/span)*9*PI;
    t.xPosition = cos((xSum/span)*9*PI)*rSum*0.4f;
    t.yPosition = sin((xSum/span)*9*PI)*rSum*0.4f;
    //println(t.xPosition+"\t"+t.yPosition+"\t"+t.rad);

    for (int j = 0; j < sw.length; j++) {
      if (sw[j].equals(t.keyword.toLowerCase())) {
        t.stopword = true;
        break;
      }
    }
  }
}


public void draw() {
  background(0xffFFFFFF);
  textAlign(CENTER, CENTER);
  noStroke();
  translate(width/2, height/2);
  
  // Title
  textFont(font1, 30);
  fill(0xff000000);
  text("100 Most Frequent Keywords Appeared in Check-out Transactions in 2012", 0, -410);
  textFont(font0, 15);
  fill(0xff6C6C6C);
  text("Source: Seattle Public Library", 0, -380);
  text("Byungkyu (Jay) Kang, January, 2013", 0, -360);
  
  textFont(font0, 17);
  text("            :keyword,             :keyword detected as a stopword (e.g. pronoun or preposition)", 0, 400);
  text("Size of Circle: Proportional to the number of occurrence in transactions (2012)", 0, 420);
  fill(0xffE86946);
  ellipse(-210, 400, 25, 25);
  fill(0xff87A644);
  ellipse(-120, 400, 25, 25);
  
  float xPrev = 0;
  float yPrev = 0;
  for (int i=0; i<tArray.size(); i++) {
    Entity t = (Entity) tArray.get(i);

    if (i>0) {
      stroke(0xff959595, 90);
      line(xPrev, yPrev, t.xPosition, t.yPosition);
      noStroke();
    }
    xPrev = t.xPosition;
    yPrev = t.yPosition;
    
    // draw a circle
//    fill(0, 100-float(i)/2, 100);
    if (t.stopword == true) {
      fill(0xff87A644);
    }else{
      fill(0xffE86946);
    }
    ellipse(t.xPosition, t.yPosition, t.rad, t.rad);
    if (t.stopword == true) {
      fill(0xffA0A0A0);
    }else{
      fill(0xff484848);
    }
//    textSize(14+2*int(log(t.rad)));
    //    rotate(-(t.angle + 0.5*PI));
    
    int fontOffsetX = 0;
    int fontOffsetY = 0;
    if ( abs(t.rad) > 30 ){
        textFont(font1, 20);
        fill(0xffFFFFFF);
    // lower left
    }else if( t.yPosition > 0 && t.xPosition < 0 ){
      textAlign(RIGHT, TOP);
      fontOffsetX = PApplet.parseInt(-t.rad/2);
      fontOffsetY = PApplet.parseInt(t.rad/2);
    // lower right
    }else if( t.yPosition > 0 && t.xPosition > 0 ){
      textAlign(LEFT, TOP);
      fontOffsetX = PApplet.parseInt(t.rad/2);
      fontOffsetY = PApplet.parseInt(t.rad/2);
    // upper left
    }else if( t.yPosition < 0 && t.xPosition < 0 ){
      textAlign(RIGHT, BOTTOM);
      fontOffsetX = PApplet.parseInt(-t.rad/2);
      fontOffsetY = PApplet.parseInt(-t.rad/2);
    // upper right
    }else if( t.yPosition < 0 && t.xPosition > 0 ){
      textAlign(LEFT, BOTTOM);
      fontOffsetX = PApplet.parseInt(t.rad/2);
      fontOffsetY = PApplet.parseInt(-t.rad/2);
    }
    text(t.keyword, t.xPosition + fontOffsetX, t.yPosition + fontOffsetY);
    textFont(font0, 17);
  }
}
//SELECT keyword, count(*) as count  FROM `keyword` group by keyword order by count desc limit 100;

class Entity 
{
  String keyword;
  int count;
  
  //specific to this particular visualization.
  float xPosition;
  float yPosition; 
  float rad;
  float angle;
  boolean stopword;
  
  Entity(String _keyword, int _count) {
    keyword = _keyword;
    count = _count;
    stopword = false;
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "KeywordFrequency2012" });
  }
}
